//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfMain *fMain;

//---------------------------------------------------------------------------
__fastcall TfMain::TfMain(TComponent* Owner)
    : TForm(Owner)
{
    // int pingtime;
    //PingCounter = 0;
    // meIP->Text = PingIP;
    // meTime->Text = PingSec;
    // pingtime = StrToInt(meTime->Text);
    // udTime->Position = pingtime;
    // trPing->Interval = pingtime * 1000;
    // 1999.04.21. IniFile Added
    Application->Title = "AutoPing - Working";
    fMain->Caption = "AutoPing - Working";
    bbWorking->Top = bbSwitch->Top;
    bbWorking->Left = bbSwitch->Left;
    dlPingStart = Now();
    asPingStart = DateTimeToStr(dlPingStart);
    HistoryFile = AppDir + "\\" + HISTORY;
}
//---------------------------------------------------------------------------
void __fastcall TfMain::trPingTimer(TObject *Sender)
{
    ShellExecute(fMain->Handle, "open",
                  "Ping", meIP->Text.c_str(), NULL, PingStatus);
    PingCounter++;
    sbPing->Panels->Items[0]->Text = "Ping " + IntToStr(PingCounter)
                                     + " times, and working "
                                     + TimeToStr(dlPingStart - Now());
    trStatusBar->Enabled = true;
}
//---------------------------------------------------------------------------


void __fastcall TfMain::udTimeClick(TObject *Sender, TUDBtnType Button)
{
     meTime->Text = IntToStr(udTime->Position);
     trPing->Interval = udTime->Position * 1000;
}
//---------------------------------------------------------------------------

void __fastcall TfMain::cbShowPingClick(TObject *Sender)
{
     if (cbShowPing->State == cbUnchecked)
         PingStatus = SW_HIDE;
     else
         PingStatus = SW_NORMAL;
}
//---------------------------------------------------------------------------

void __fastcall TfMain::trStatusBarTimer(TObject *Sender)
{
    sbPing->Panels->Items[0]->Text = "";
    trStatusBar->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TfMain::bbSwitchClick(TObject *Sender)
{
     trPing->Enabled = false;
     bbSwitch->Tag = 1;
     bbSwitch->Visible = false;
     bbWorking->Visible = true;
     Application->Title = "AutoPing - Pause";
     fMain->Caption = "AutoPing - Pause";
     dlPingEnd = Now();
     asPingEnd = DateTimeToStr(dlPingEnd);
     dlPingPeriod = dlPingEnd - dlPingStart;
     asPingPeriod = TimeToStr(dlPingPeriod);
     dlTimeTotal += dlPingPeriod;
     asTimeTotal = TimeToStr(dlTimeTotal);
     //Add     Error Total Fix  1999.05.24.
     TIniFile *PingIni = new TIniFile(AppDir + "\\AutoPing.ini");
     PingIni->WriteString("History","TotalTime",dlTimeTotal);
     delete PingIni;
     //End Add  1999.05.24.
     WriteHistory(HistoryFile,asPingStart,asPingEnd,asPingPeriod,asTimeTotal);
}
//---------------------------------------------------------------------------


void __fastcall TfMain::bbWorkingClick(TObject *Sender)
{
     trPing->Enabled = true;
     bbWorking->Visible = false;
     bbSwitch->Visible = true;
     Application->Title = "AutoPing - Working";
     fMain->Caption = "AutoPing - Working";
     dlPingStart = Now();
     asPingStart = DateTimeToStr(dlPingStart);
}
//---------------------------------------------------------------------------

void __fastcall TfMain::FormClose(TObject *Sender, TCloseAction &Action)
{
     TIniFile *PingIni = new TIniFile(AppDir + "\\AutoPing.ini");
     PingIni->WriteString("RunParameters","ShowPing",
                           IntToStr(cbShowPing->Checked));
     PingIni->WriteString("RunParameters","PingAddress",
                           meIP->Text);
     PingIni->WriteString("RunParameters","TimeInterval",
                           IntToStr(trPing->Interval));
     PingIni->WriteString("AppPos","Left",IntToStr(fMain->Left));
     PingIni->WriteString("AppPos","Top",IntToStr(fMain->Top));
     PingIni->WriteString("AppPos","WindowSize",
                           IntToStr(cbRunMinimized->Checked));
     PingIni->WriteString("History","PingCounter",PingCounter);
     dlPingEnd = Now();
     asPingEnd = DateTimeToStr(dlPingEnd);
     dlPingPeriod = dlPingEnd - dlPingStart;
     asPingPeriod = TimeToStr(dlPingPeriod);
     dlTimeTotal += dlPingPeriod;
     asTimeTotal = TimeToStr(dlTimeTotal);
//     PingIni->WriteString("History","TotalTime",dlTimeTotal);
//     Error Total Fix  1999.05.24.

     if (trPing->Enabled)
     {
         PingIni->WriteString("History","TotalTime",dlTimeTotal);
         WriteHistory(HistoryFile,asPingStart
                                 ,asPingEnd, asPingPeriod, asTimeTotal);
     }

     delete PingIni;
}
//---------------------------------------------------------------------------


void __fastcall TfMain::FormCreate(TObject *Sender)
{
    AppDir = GetCurrentDir();
    TIniFile *PingIni = new TIniFile(AppDir + "\\AutoPing.ini");
    cbShowPing->Checked = PingIni->ReadBool("RunParameters","ShowPing",
                          false);
    meIP->Text = PingIni->ReadString("RunParameters","PingAddress",
                                     "127.0.0.1");
    trPing->Interval = PingIni->ReadInteger("RunParameters",
                       "TimeInterval",10000);
    udTime->Position = trPing->Interval / 1000;
    meTime->Text = IntToStr(udTime->Position);
    fMain->Left = PingIni->ReadInteger("AppPos","Left",262);
    fMain->Top = PingIni->ReadInteger("AppPos","Top",230);
    fMain->WindowState = PingIni->ReadInteger("AppPos","WindowSize",1);
    cbRunMinimized->Checked = PingIni->ReadInteger("AppPos","WindowSize",1);
    PingCounter = PingIni->ReadInteger("History","PingCounter",0);
    dlTimeTotal = StrToFloat(PingIni->ReadString("History","TotalTime",0));
    delete PingIni;
}
//---------------------------------------------------------------------------

void __fastcall TfMain::WriteHistory(AnsiString asFileName,
                                     AnsiString asPingStart,
                                     AnsiString asPingEnd,
                                     AnsiString asPingPeriod,
                                     AnsiString asTimeTotal)
{
    FILE *PingHistory;
    PingHistory = fopen(asFileName.c_str(),"a+");
    fprintf(PingHistory,"%s,%s,%s,%s\n",asPingStart
                                       ,asPingEnd
                                       ,asPingPeriod
                                       ,asTimeTotal);
    fclose(PingHistory);
}
//---------------------------------------------------------------------------
void __fastcall TfMain::Open1Click(TObject *Sender)
{

    ShellExecute(fMain->Handle, "open",
                 HistoryFile.c_str(),
                 meIP->Text.c_str(), NULL, SW_NORMAL);
}
//---------------------------------------------------------------------------

void __fastcall TfMain::Print1Click(TObject *Sender)
{
    ShellExecute(fMain->Handle, "print",
                 HistoryFile.c_str(),
                 meIP->Text.c_str(), NULL, SW_HIDE);
}
//---------------------------------------------------------------------------

void __fastcall TfMain::Clear1Click(TObject *Sender)
{
    FILE *NewFile;
    try
    {
       NewFile = fopen(HistoryFile.c_str(),"w");
       fclose(NewFile);
    }
    catch (...)
    {
       fclose(NewFile);
    }

    dlTimeTotal = 0.0;
    TIniFile *PingIni;
    try
    {
       PingIni = new TIniFile(AppDir + "\\AutoPing.ini");
       PingIni->WriteString("History","TotalTime",dlTimeTotal);
       delete PingIni;
    }
    catch(...)
    {
       delete PingIni;
    }

}
//---------------------------------------------------------------------------

void __fastcall TfMain::Show1Click(TObject *Sender)
{
    ShowMessage("Total times: " + IntToStr(PingCounter));    
}
//---------------------------------------------------------------------------

void __fastcall TfMain::Reset1Click(TObject *Sender)
{
    PingCounter = 0;    
}
//---------------------------------------------------------------------------

void __fastcall TfMain::QuitQ1Click(TObject *Sender)
{
    Close();    
}
//---------------------------------------------------------------------------

